/********************************************************************************
 * ePIMSs $Source$
 * ePIMSs $Project$
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author$
 *
 * @source $Source$
 * @path $FPath$
 * @project $Project$
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author$
 * @lastChangedDate $Date$
 *
 * @version $Revision$ $Date$
 *
 * @changeRequest $CR$
 * @state $State$
 ********************************************************************************/



package _com.epimss.lab.converters;


import org.eclipse.core.databinding.conversion.IConverter;

import static org.codehaus.groovy.runtime.DefaultGroovyMethods.*

import java.text.NumberFormat

import java.math.BigInteger


/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  March 22, 2011 3:51:49 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */
class StringToBigIntegerConverter implements IConverter
{
    //~ Methods ----------------------------------------------------------------
    
    /**
     * The <code>convert()</code> method TODO!
     *
     * @created  March 22, 2011 3:51:49 PM by St Clair Clarke
     *
     * @param    fromObject  Object TODO!
     *
     * @return   <code>Object</code> type if suscessfully executes.
     *
     * @see      com.epimss.shared.converters.BigIntegerToStringConverter#convert(com.epimss.shared.converters.BigIntegerToStringConverter)
     * @since    1.0
     */
    @Override
    Object convert( Object fromObject )
    {
        String masked  = fromObject.toString()
        String unmasked = ''
        
        masked.each(
                { character ->
                    if( !character.matches(/[\p{Blank}\(\)-]/))
                        unmasked += character
                })
        
        unmasked.toBigInteger()
    }   // end method convert
    
    
    
    
    /**
     * The <code>getFromType()</code> method TODO!
     *
     * @created  March 22, 2011 3:51:49 PM by St Clair Clarke
     *
     * @return   <code>Object</code> type if suscessfully executes.
     *
     * @see      org.eclipse.core.databinding.conversion.IConverter#getFromType()
     * @since    1.0
     */
    @Override
    Object getFromType()
    {
        String.class
    }   // end method getFromType
    
    
    
    /**
     * The <code>getToType()</code> method TODO!
     *
     * @created  March 22, 2011 3:51:49 PM by St Clair Clarke
     *
     * @return   <code>Object</code> type if suscessfully executes.
     *
     * @see      org.eclipse.core.databinding.conversion.IConverter#getToType()
     * @since    1.0
     */
    @Override
    Object getToType()
    {
        BigInteger.class
    }   // end method getToType
    
}   // end class StringToBigIntegerConverter
