/********************************************************************************
 * ePIMSs $Source$
 * ePIMSs $Project$
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author$
 *
 * @source $Source$
 * @path $FPath$

 * @project $Project$
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author$
 * @lastChangedDate $Date$
 *
 * @version $Revision$ $Date$
 *
 * @changeRequest $CR$
 * @state $State$
 ********************************************************************************/


package _com.epimss.lab.ui.misc;


import _com.epimss.lab.converters.BigIntegerToStringConverter;
import _com.epimss.lab.converters.DateToStringConverter;
import _com.epimss.lab.converters.StringToBigIntegerConverter;
import _com.epimss.lab.converters.StringToDateConverter;

import _com.epimss.lab.data.misc.RequestDateAndNumber;

import com.richclientgui.toolbox.propagate.PropagateComposite;

import java.util.Date;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.UpdateValueStrategy;

import org.eclipse.core.databinding.beans.BeansObservables;

import org.eclipse.core.databinding.observable.value.IObservableValue;

import org.eclipse.jface.databinding.swt.SWTObservables;

import org.eclipse.nebula.widgets.cdatetime.CDT;
import org.eclipse.nebula.widgets.cdatetime.CDateTime;

import org.eclipse.nebula.widgets.formattedtext.FormattedText;
import org.eclipse.nebula.widgets.formattedtext.MaskFormatter;

import org.eclipse.swt.SWT;

import org.eclipse.swt.custom.CLabel;

import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import org.eclipse.ui.forms.widgets.FormToolkit;

/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  May 20, 2011 8:54:47 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */
public class RequestDateAndNumberForm extends Composite
{
    //~ Instance fields --------------------------------------------------------

    private final FormToolkit    toolkit                = new FormToolkit( Display.getCurrent() );

    private CDateTime            requestDateAndTimeCDT;
    private CDateTime            testDateAndTimeCDT;
    private CLabel               mrnCLbl;
    private CLabel               requestDateAndTimeCLbl;
    private CLabel               requestNumberCLbl;
    private CLabel               testDateAndTimeCLbl;
    private DataBindingContext   m_bindingContext;

    private FormattedText        mrnFrmtdTxt;
    private FormattedText        numberFrmtdTxt;

    private PropagateComposite   rootPrpgteCmpst;

    private RequestDateAndNumber requestDateAndNumber   = new RequestDateAndNumber();

    private Text                 mrnTxt;
    private Text                 numberTxt;
    private Text                 requestDateAndTimeTxt;
    private Text                 testDateAndTimeTxt;

    //~ public -----------------------------------------------------------------

    /**
     * Creates a new <code>RequestDateAndNumberBaseForm</code> object.
     *
     * @created  May 20, 2011 9:30:06 PM by St Clair Clarke
     *
     * @param    parent  <code>Composite</code> TODO!
     * @param    style   <code>int</code> TODO!
     *
     * @since    1.0
     */
    public RequestDateAndNumberForm( Composite parent, int style )
    {
        super( parent, style );

        try
        {
            createContents();

            requestDateAndTimeTxt.setVisible( false );
            testDateAndTimeTxt.setVisible( false );

        }
        catch( Exception e )
        {
            System.err.println( "com.epimss.lab.ui.misc.RequestDateAndNumberForm.RequestDateAndNumberForm(parent, style)," + e );

        }   // end try-catch

    }   // end ctor RequestDateAndNumberForm

    //~ Methods ----------------------------------------------------------------

    /**
     * The <code>doGetRequestDateAndTime()</code> method TODO!
     *
     * @created  May 23, 2011 8:33:03 AM by St Clair Clarke
     *
     * @return   <code>Date</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Date doGetRequestDateAndTime()
    {
        return( requestDateAndNumber.getRequestDateAndTime() );

    }   // end method doGetRequestDateAndTime


    /**
     * The <code>doGetTestDateAndTime()</code> method TODO!
     *
     * @created  May 23, 2011 8:33:03 AM by St Clair Clarke
     *
     * @return   <code>Date</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Date doGetTestDateAndTime()
    {
        return( requestDateAndNumber.getTestDateAndTime() );

    }   // end method doGetTestDateAndTime


    /**
     * The <code>initDataBindings()</code> method TODO!
     *
     * @created  June 24, 2011 10:57:45 PM by St Clair Clarke
     *
     * @return   <code>DataBindingContext</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected DataBindingContext initDataBindings()
    {
        DataBindingContext bindingContext = new DataBindingContext();

        //
        try
        {
            IObservableValue    mrnTxtObserveTextObserveWidget      = SWTObservables.observeText( mrnTxt, SWT.Modify );
            IObservableValue    requestDateAndNumberMrnObserveValue = BeansObservables.observeValue( requestDateAndNumber, "mrn" );
            UpdateValueStrategy strategy                            = new UpdateValueStrategy();
            strategy.setConverter( new StringToBigIntegerConverter() );

            UpdateValueStrategy strategy_1 = new UpdateValueStrategy();
            strategy_1.setConverter( new BigIntegerToStringConverter() );
            bindingContext.bindValue( mrnTxtObserveTextObserveWidget, requestDateAndNumberMrnObserveValue, strategy, strategy_1 );

            //
            IObservableValue    numberTxtObserveTextObserveWidget      = SWTObservables.observeText( numberTxt, SWT.Modify );
            IObservableValue    requestDateAndNumberNumberObserveValue = BeansObservables.observeValue( requestDateAndNumber, "number" );
            UpdateValueStrategy strategy_2                             = new UpdateValueStrategy();
            strategy_2.setConverter( new StringToBigIntegerConverter() );

            UpdateValueStrategy strategy_3 = new UpdateValueStrategy();
            strategy_3.setConverter( new BigIntegerToStringConverter() );
            bindingContext.bindValue( numberTxtObserveTextObserveWidget, requestDateAndNumberNumberObserveValue, strategy_2, strategy_3 );

            //
            IObservableValue    requestDateAndTimeTxtObserveTextObserveWidget      = SWTObservables.observeText( requestDateAndTimeTxt, SWT.Modify );
            IObservableValue    requestDateAndNumberRequestDateAndTimeObserveValue = BeansObservables.observeValue( requestDateAndNumber, "requestDateAndTime" );
            UpdateValueStrategy strategy_4                                         = new UpdateValueStrategy();
            strategy_4.setConverter( new StringToDateConverter() );

            UpdateValueStrategy strategy_5 = new UpdateValueStrategy();
            strategy_5.setConverter( new DateToStringConverter() );
            bindingContext.bindValue( requestDateAndTimeTxtObserveTextObserveWidget, requestDateAndNumberRequestDateAndTimeObserveValue, strategy_4, strategy_5 );

            //
            IObservableValue    testDateAndTimeTxtObserveTextObserveWidget      = SWTObservables.observeText( testDateAndTimeTxt, SWT.Modify );
            IObservableValue    requestDateAndNumberTestDateAndTimeObserveValue = BeansObservables.observeValue( requestDateAndNumber, "testDateAndTime" );
            UpdateValueStrategy strategy_6                                      = new UpdateValueStrategy();
            strategy_6.setConverter( new StringToDateConverter() );

            UpdateValueStrategy strategy_7 = new UpdateValueStrategy();
            strategy_7.setConverter( new DateToStringConverter() );
            bindingContext.bindValue( testDateAndTimeTxtObserveTextObserveWidget, requestDateAndNumberTestDateAndTimeObserveValue, strategy_6, strategy_7 );

        }
        catch( Throwable e )
        {
            System.err.println( "com.epimss.lab.ui.misc.RequestDateAndNumberBaseForm.initDataBindings(), " + e );

        }   // end try-catch

        //
        return( bindingContext );

    }   // end method initDataBindings


    /**
     * The <code>createContents()</code> method TODO!
     *
     * @created  May 20, 2011 8:54:47 PM by St Clair Clarke
     * @since    1.0
     */
    private void createContents()
    {
        addDisposeListener( new DisposeListener()
            {
                @Override
                public void widgetDisposed( DisposeEvent e )
                {
                    toolkit.dispose();

                }   // end method widgetDisposed

            } );
        toolkit.adapt( this );
        toolkit.paintBordersFor( this );
        setLayout( new GridLayout() );

        {
            rootPrpgteCmpst = new PropagateComposite( this, SWT.NONE );
            rootPrpgteCmpst.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
            rootPrpgteCmpst.setData( "name", "rootPrpgteCmpst" );
            toolkit.adapt( rootPrpgteCmpst );
            toolkit.paintBordersFor( rootPrpgteCmpst );
            rootPrpgteCmpst.setLayout( new GridLayout( 6, false ) );

            {
                mrnCLbl = new CLabel( rootPrpgteCmpst, SWT.NONE );
                mrnCLbl.setLayoutData( new GridData( SWT.CENTER, SWT.CENTER, false, false, 1, 1 ) );
                mrnCLbl.setToolTipText( "MRN = Medical Record Number" );
                mrnCLbl.setData( "name", "mrnCLbl" );
                toolkit.adapt( mrnCLbl );
                toolkit.paintBordersFor( mrnCLbl );
                mrnCLbl.setText( "MRN" );

            }

            {
                requestNumberCLbl = new CLabel( rootPrpgteCmpst, SWT.NONE );
                requestNumberCLbl.setLayoutData( new GridData( SWT.CENTER, SWT.CENTER, false, false, 1, 1 ) );
                toolkit.adapt( requestNumberCLbl );
                toolkit.paintBordersFor( requestNumberCLbl );
                requestNumberCLbl.setText( "Request Number" );

            }

            new Label( rootPrpgteCmpst, SWT.NONE );
            new Label( rootPrpgteCmpst, SWT.NONE );

            {
                requestDateAndTimeCLbl = new CLabel( rootPrpgteCmpst, SWT.NONE );
                requestDateAndTimeCLbl.setLayoutData( new GridData( SWT.CENTER, SWT.CENTER, false, false, 1, 1 ) );
                requestDateAndTimeCLbl.setData( "name", "requestDateAndTimeCLbl" );
                toolkit.adapt( requestDateAndTimeCLbl );
                toolkit.paintBordersFor( requestDateAndTimeCLbl );
                requestDateAndTimeCLbl.setText( "Request Date and Time" );

            }

            {
                testDateAndTimeCLbl = new CLabel( rootPrpgteCmpst, SWT.NONE );
                testDateAndTimeCLbl.setLayoutData( new GridData( SWT.CENTER, SWT.CENTER, false, false, 1, 1 ) );
                toolkit.adapt( testDateAndTimeCLbl );
                toolkit.paintBordersFor( testDateAndTimeCLbl );
                testDateAndTimeCLbl.setText( "Test Date and Time" );

            }

            {
                mrnFrmtdTxt = new FormattedText( rootPrpgteCmpst, SWT.BORDER );
                mrnFrmtdTxt.setFormatter( new MaskFormatter( "### ### ### ###" ) );
                mrnTxt = mrnFrmtdTxt.getControl();

                {
                    GridData gd_mrnTxt = new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 );
                    gd_mrnTxt.widthHint = 80;
                    mrnTxt.setLayoutData( gd_mrnTxt );

                }

                mrnTxt.setData( "name", "mrnTxt" );

            }

            {
                numberFrmtdTxt = new FormattedText( rootPrpgteCmpst, SWT.BORDER );
                numberFrmtdTxt.setFormatter( new MaskFormatter( "### ### ### ###" ) );
                numberTxt = numberFrmtdTxt.getControl();

                {
                    GridData gd_numberTxt = new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 );
                    gd_numberTxt.widthHint = 80;
                    numberTxt.setLayoutData( gd_numberTxt );

                }

                numberTxt.setData( "name", "numberTxt" );

            }

            {
                requestDateAndTimeTxt = new Text( rootPrpgteCmpst, SWT.BORDER );

                {
                    GridData gd_requestDateAndTimeTxt = new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 );
                    gd_requestDateAndTimeTxt.widthHint = 1;
                    requestDateAndTimeTxt.setLayoutData( gd_requestDateAndTimeTxt );

                }

                requestDateAndTimeTxt.setData( "name", "requestDateAndTimeTxt" );
                toolkit.adapt( requestDateAndTimeTxt, true, true );

            }

            {
                testDateAndTimeTxt = toolkit.createText( rootPrpgteCmpst, "New Text", SWT.NONE );

                {
                    GridData gd_testDateAndTimeTxt = new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 );
                    gd_testDateAndTimeTxt.widthHint = 0;
                    testDateAndTimeTxt.setLayoutData( gd_testDateAndTimeTxt );

                }

                testDateAndTimeTxt.setData( "name", "testDateAndTimeTxt" );

            }

            {
                requestDateAndTimeCDT = new CDateTime( rootPrpgteCmpst, CDT.BORDER | CDT.TAB_FIELDS | CDT.CLOCK_12_HOUR | CDT.DROP_DOWN | CDT.DATE_MEDIUM | CDT.TIME_MEDIUM );
                requestDateAndTimeCDT.addSelectionListener( new SelectionAdapter()
                    {
                        @Override
                        public void widgetSelected( SelectionEvent e )
                        {
                            requestDateAndNumber.setRequestDateAndTime( requestDateAndTimeCDT.getSelection() );

                            // doGetRequestDateAndTime();
                            requestDateAndTimeTxt.setText( requestDateAndTimeCDT.getText() );
                            isFormValid();

                        }   // end method widgetSelected

                    } );

                {
                    GridData gd_requestDateAndTimeCDT = new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 );
                    gd_requestDateAndTimeCDT.widthHint = 140;
                    requestDateAndTimeCDT.setLayoutData( gd_requestDateAndTimeCDT );

                }

                requestDateAndTimeCDT.setData( "name", "requestDateAndTimeCDT" );
                toolkit.adapt( requestDateAndTimeCDT );
                toolkit.paintBordersFor( requestDateAndTimeCDT );

            }

            {
                testDateAndTimeCDT = new CDateTime( rootPrpgteCmpst, CDT.BORDER | CDT.TAB_FIELDS | CDT.CLOCK_12_HOUR | CDT.DROP_DOWN | CDT.DATE_MEDIUM | CDT.TIME_MEDIUM );
                testDateAndTimeCDT.addSelectionListener( new SelectionAdapter()
                    {
                        @Override
                        public void widgetSelected( SelectionEvent e )
                        {
                            requestDateAndNumber.setTestDateAndTime( testDateAndTimeCDT.getSelection() );
                            doGetTestDateAndTime();
                            testDateAndTimeTxt.setText( testDateAndTimeCDT.getText() );
                            isFormValid();

                        }   // end method widgetSelected

                    } );

                {
                    GridData gd_testDateAndTimeCDT = new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 );
                    gd_testDateAndTimeCDT.widthHint = 140;
                    testDateAndTimeCDT.setLayoutData( gd_testDateAndTimeCDT );

                }

                testDateAndTimeCDT.setData( "name", "testDateAndTimeCDT" );
                toolkit.adapt( testDateAndTimeCDT );
                toolkit.paintBordersFor( testDateAndTimeCDT );

            }

        }

        m_bindingContext = initDataBindings();

    }   // end method createContents


    /**
     * Retrieves the <code>formValid</code> property from this bean.
     *
     * @created  May 21, 2011 8:45:42 PM by St Clair Clarke
     *
     * @return   <code>Boolean</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Boolean isFormValid()
    {
        if(
           ( requestDateAndTimeCDT.getSelection() != null )
               &&
               ( testDateAndTimeCDT.getSelection() != null )
        )
        {
            return( true );

        }   // end if

        return( false );

    }   // end method isFormValid


    /**
     * Retrieves the <code>mrnTxt</code> property from this bean.
     *
     * @created  May 23, 2011 8:01:17 AM by St Clair Clarke
     *
     * @return   <code>Text</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Text getMrnTxt()
    {
        return( mrnTxt );

    }   // end method getMrnTxt


    /**
     * Retrieves the <code>numberTxt</code> property from this bean.
     *
     * @created  May 23, 2011 8:01:17 AM by St Clair Clarke
     *
     * @return   <code>Text</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Text getNumberTxt()
    {
        return( numberTxt );

    }   // end method getNumberTxt


    /**
     * Retrieves the <code>requestDateAndNumber</code> property from this bean.
     *
     * @created  June 6, 2011 4:10:12 PM by St Clair Clarke
     *
     * @return   <code>RequestDateAndNumber</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public RequestDateAndNumber getRequestDateAndNumber()
    {
        return( requestDateAndNumber );

    }   // end method getRequestDateAndNumber


    /**
     * Retrieves the <code>requestDateAndTimeCDT</code> property from this bean.
     *
     * @created  May 21, 2011 3:12:26 PM by St Clair Clarke
     *
     * @return   <code>CDateTime</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public CDateTime getRequestDateAndTimeCDT()
    {
        return( requestDateAndTimeCDT );

    }   // end method getRequestDateAndTimeCDT


    /**
     * Retrieves the <code>requestDateAndTimeTxt</code> property from this bean.
     *
     * @created  June 24, 2011 4:08:08 PM by St Clair Clarke
     *
     * @return   <code>Text</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Text getRequestDateAndTimeTxt()
    {
        return( requestDateAndTimeTxt );

    }   // end method getRequestDateAndTimeTxt


    /**
     * Retrieves the <code>testDateAndTimeCDT</code> property from this bean.
     *
     * @created  May 21, 2011 3:12:26 PM by St Clair Clarke
     *
     * @return   <code>CDateTime</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public CDateTime getTestDateAndTimeCDT()
    {
        return( testDateAndTimeCDT );

    }   // end method getTestDateAndTimeCDT


    /**
     * Retrieves the <code>testDateAndTimeTxt</code> property from this bean.
     *
     * @created  June 24, 2011 4:08:08 PM by St Clair Clarke
     *
     * @return   <code>Text</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public Text getTestDateAndTimeTxt()
    {
        return( testDateAndTimeTxt );

    }   // end method getTestDateAndTimeTxt

}   // end class RequestDateAndNumberForm
